diff -uNrd ircd-hybrid-7rc3/src/channel.c ircd-hoho-2r15/src/channel.c
--- ircd-hybrid-7rc3/src/channel.c	Tue Aug 20 12:41:59 2002
+++ ircd-hoho-2r15/src/channel.c	Fri Dec 20 15:37:24 2002
@@ -365,6 +365,9 @@
   if (IsCapable(client_p, CAP_EX))
     send_mode_list(client_p, chptr->chname, &chptr->exceptlist, 'e', 0);
 
+  if (IsCapable(client_p, CAP_QU))
+	send_mode_list(client_p, chptr->chname, &chptr->quietlist, 'q', 0);
+
   if (IsCapable(client_p, CAP_IE))
     send_mode_list(client_p, chptr->chname, &chptr->invexlist, 'I', 0);
 }
@@ -406,6 +409,7 @@
   for (lp = top->head; lp; lp = lp->next)
   {
     banptr = lp->data;
+
     tlen = strlen(banptr->banstr);
     tlen++;
 
@@ -1051,6 +1055,7 @@
  *              - pointer to client to check access fo
  * output       - returns an int 0 if not banned,
  *                CHFL_BAN if banned
+ *                CHFL_QUIET if cannot send to channel
  *
  * IP_BAN_ALL from comstud
  * always on...
@@ -1061,16 +1066,15 @@
 is_banned(struct Channel *chptr, struct Client *who)
 {
   char src_host[NICKLEN + USERLEN + HOSTLEN + 6];
-  char src_iphost[NICKLEN + USERLEN + HOSTLEN + 6];
 
   if (!IsPerson(who))
     return (0);
 
   ircsprintf(src_host,"%s!%s@%s", who->name, who->username, who->host);
-  ircsprintf(src_iphost,"%s!%s@%s", who->name, who->username,
-	     who->localClient->sockhost);
+//  ircsprintf(src_iphost,"%s!%s@%s", who->name, who->username,
+//	     who->localClient->sockhost);
 
-  return (check_banned(chptr, who, src_host, src_iphost));
+  return (check_banned(chptr, who, src_host, src_host));
 }
 
 /*
@@ -1082,6 +1086,7 @@
  *              - pointer to pre-formed nick!user@ip
  * output       - returns an int 0 if not banned,
  *                CHFL_BAN if banned
+ *                CHFL_QUIET if cannot send to channel
  *
  * IP_BAN_ALL from comstud
  * always on...
@@ -1095,16 +1100,34 @@
   dlink_node *except;
   struct Ban *actualBan = NULL;
   struct Ban *actualExcept = NULL;
+  int quiet_too = 0;
 
   for (ban = chptr->banlist.head; ban; ban = ban->next)
   {
     actualBan = ban->data;
-    if (match(actualBan->banstr, s) || match(actualBan->banstr, s2))
-      break;
-    else
+    if (match(actualBan->banstr, s) || match(actualBan->banstr, s2)) {
+		if(ConfigChannel.quiet_on_ban == 1)
+			quiet_too = CHFL_QUIET;
+		break;
+    } else {
       actualBan = NULL;
+	}
+  }
+
+  if(actualBan == NULL) {
+    for (ban = chptr->quietlist.head; ban; ban = ban->next)
+    {
+      actualBan = ban->data;
+      if (match(actualBan->banstr, s) || match(actualBan->banstr, s2)) {
+		quiet_too = CHFL_QUIET;
+		break;
+      } else {
+        actualBan = NULL;
+      }
+    }
   }
 
+
   if ((actualBan != NULL) && ConfigChannel.use_except)
   {
     for (except = chptr->exceptlist.head; except; except = except->next)
@@ -1118,7 +1141,7 @@
     }
   }
 
-  return ((actualBan ? CHFL_BAN : 0));
+  return ((actualBan ? CHFL_BAN | quiet_too : 0));
 }
 
 /* small series of "helper" functions */
@@ -1146,7 +1169,7 @@
   ircsprintf(src_iphost,"%s!%s@%s", source_p->name, source_p->username,
 	     source_p->localClient->sockhost);
 
-  if ((check_banned(chptr, source_p, src_host, src_iphost)) == CHFL_BAN)
+  if ((check_banned(chptr, source_p, src_host, src_iphost)) & CHFL_BAN)
     return (ERR_BANNEDFROMCHAN);
 
   if (chptr->mode.mode & MODE_INVITEONLY)
@@ -1288,7 +1311,7 @@
 int
 can_send(struct Channel *chptr, struct Client *source_p)
 {
-  if(MyClient(source_p) && find_channel_resv(chptr->chname))
+if(MyClient(source_p) && find_channel_resv(chptr->chname))
     return CAN_SEND_NO;
     
   if (is_any_op(chptr, source_p))
@@ -1298,14 +1321,11 @@
   if (IsServer(source_p))
     return CAN_SEND_OPV;
 
-  if (chptr->mode.mode & MODE_MODERATED)
+  if (chptr->mode.mode & MODE_MODERATED) 
     return CAN_SEND_NO;
 
-  if (ConfigChannel.quiet_on_ban && MyClient(source_p) &&
-      (is_banned(chptr, source_p) == CHFL_BAN))
-  {
-    return (CAN_SEND_NO);
-  }
+  if (is_banned(chptr, source_p) & CHFL_QUIET)
+    return CAN_SEND_NO;
 
   if (chptr->mode.mode & MODE_NOPRIVMSGS && !IsMember(source_p, chptr))
     return (CAN_SEND_NO);
diff -uNrd ircd-hybrid-7rc3/src/channel_mode.c ircd-hoho-2r15/src/channel_mode.c
--- ircd-hybrid-7rc3/src/channel_mode.c	Tue Aug 20 15:25:30 2002
+++ ircd-hoho-2r15/src/channel_mode.c	Fri Dec 20 15:37:24 2002
@@ -102,6 +102,10 @@
                     int *, char **, int *, int, int, char, void *,
                     const char *chname);
 
+static void chm_quiet(struct Client *, struct Client *,
+				    struct Channel *, int, int *, char **, int *,
+					int, int, char, void *, const char *chname);
+
 static void chm_except(struct Client *, struct Client *, struct Channel *,
                        int, int *, char **, int *, int, int, char, void *,
                        const char *chname);
@@ -149,7 +153,7 @@
 
 static int mode_limit;
 
-static int channel_capabs[] = { CAP_HOPS, CAP_AOPS, CAP_EX, CAP_IE, CAP_UID };
+static int channel_capabs[] = { CAP_HOPS, CAP_AOPS, CAP_EX, CAP_IE, CAP_UID, CAP_QU };
 
 #define NCHCAPS         (sizeof(channel_capabs)/sizeof(int))
 #define NCHCAP_COMBOS   (1 << NCHCAPS)
@@ -188,7 +192,7 @@
 }
 
 /*
- * Ban functions to work with mode +b/e/d/I
+ * Ban functions to work with mode +b/e/d/I/q
  */
 /* add the specified ID to the channel.. 
  *   -is 8/9/00 
@@ -220,6 +224,9 @@
     case CHFL_BAN:
       list = &chptr->banlist;
       break;
+    case CHFL_QUIET:
+      list = &chptr->quietlist;
+      break;
     case CHFL_EXCEPTION:
       list = &chptr->exceptlist;
       break;
@@ -287,6 +294,9 @@
 
   switch (type)
   {
+    case CHFL_QUIET:
+	  list = &chptr->quietlist;
+	  break;
     case CHFL_BAN:
       list = &chptr->banlist;
       break;
@@ -803,7 +813,7 @@
   /* dont allow halfops to set +-p, as this controls whether they can set
    * +-h or not.. all other simple modes are ok
    */
-  if((alev < CHACCESS_HALFOP) ||
+  if((alev < CHACCESS_HALFOP && !IsOper(source_p)) ||
     ((mode_type == MODE_PRIVATE) && (alev < CHACCESS_CHANOP)))
   {
     if (!(*errors & SM_ERR_NOOPS))
@@ -914,6 +924,7 @@
       DLINK_FOREACH(ptr, chptr->banlist.head)
       {
         banptr = ptr->data;
+
         sendto_one(client_p, form_str(RPL_BANLIST),
                    me.name, client_p->name, chname,
                    banptr->banstr, me.name, banptr->when);
@@ -923,6 +934,7 @@
       DLINK_FOREACH(ptr, chptr->banlist.head)
       {
         banptr = ptr->data;
+
         sendto_one(client_p, form_str(RPL_BANLIST),
                    me.name, client_p->name, chname,
                    banptr->banstr, banptr->who, banptr->when);
@@ -932,7 +944,7 @@
     return;
   }
 
-  if (alev < CHACCESS_HALFOP)
+  if (alev < CHACCESS_HALFOP && !IsOper(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -993,6 +1005,108 @@
 }
 
 static void
+chm_quiet(struct Client *client_p, struct Client *source_p,
+        struct Channel *chptr, int parc, int *parn,
+        char **parv, int *errors, int alev, int dir, char c, void *d,
+        const char *chname)
+{
+  char *mask;
+  char *raw_mask;
+  dlink_node *ptr;
+  struct Ban *banptr;
+
+
+if (dir == 0 || parc <= *parn)
+  {
+    if ((*errors & SM_ERR_RPL_B) != 0)
+      return;
+    *errors |= SM_ERR_RPL_B;
+
+#ifdef ANONOPS
+    if ((chptr->mode.mode & MODE_HIDEOPS) && (alev < CHACCESS_HALFOP))
+	  DLINK_FOREACH(ptr, chptr->quietlist.head)
+      {
+        banptr = ptr->data;
+        sendto_one(client_p, form_str(RPL_QUIETLIST),
+                   me.name, client_p->name, chname,
+                   banptr->banstr, me.name, banptr->when);
+      }
+    else
+#endif
+	  DLINK_FOREACH(ptr, chptr->quietlist.head)
+      {
+        banptr = ptr->data;
+        sendto_one(client_p, form_str(RPL_QUIETLIST),
+         me.name, client_p->name, chname,
+         banptr->banstr, banptr->who, banptr->when);
+      }
+    sendto_one(source_p, form_str(RPL_ENDOFQUIETLIST), me.name,
+               source_p->name, chname);
+    return;
+  }
+
+  if (alev < CHACCESS_HALFOP && !IsOper(source_p))
+  {
+    if (!(*errors & SM_ERR_NOOPS))
+      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+                 source_p->name, chname);
+    *errors |= SM_ERR_NOOPS;
+    return;
+  }
+
+  if (MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
+    return;
+
+  raw_mask = parv[(*parn)++];
+
+  if (IsServer(client_p))
+    mask = raw_mask;
+  else
+    mask = pretty_mask(raw_mask);
+
+  /* We'd have problems parsing this, hyb6 does it too */
+  if (strlen(mask) > (MODEBUFLEN - 2))
+    return;
+
+  /* if we're adding a NEW id */
+  if (dir == MODE_ADD)
+  {
+    if((add_id(source_p, chptr, mask, CHFL_QUIET) == 0) && MyClient(source_p))
+      return;
+
+    mode_changes[mode_count].letter = c;
+	mode_changes[mode_count].dir = MODE_ADD;
+    mode_changes[mode_count].caps = CAP_QU;
+    mode_changes[mode_count].nocaps = 0;
+    mode_changes[mode_count].mems = ALL_MEMBERS;
+    mode_changes[mode_count].id = NULL;
+    mode_changes[mode_count++].arg = mask;
+  }
+  else if (dir == MODE_DEL)
+  {
+    if (del_id(chptr, mask, CHFL_QUIET) != 0)
+    {
+      /* mask isn't a valid ban, check raw_mask */
+      if ((del_id(chptr, raw_mask, CHFL_QUIET) != 0)  && MyClient(source_p))
+      {
+        /* nope */
+        return;
+      }
+      mask = raw_mask;
+    }
+
+    mode_changes[mode_count].letter = c;
+	mode_changes[mode_count].dir = MODE_DEL;
+    mode_changes[mode_count].caps = CAP_QU;
+    mode_changes[mode_count].nocaps = 0;
+    mode_changes[mode_count].mems = ALL_MEMBERS;
+    mode_changes[mode_count].id = NULL;
+    mode_changes[mode_count++].arg = mask;
+  }
+}
+
+
+static void
 chm_except(struct Client *client_p, struct Client *source_p,
            struct Channel *chptr, int parc, int *parn,
            char **parv, int *errors, int alev, int dir, char c, void *d,
@@ -1016,7 +1130,7 @@
     return;
   }
 
-  if (alev < CHACCESS_HALFOP)
+  if (alev < CHACCESS_HALFOP && !IsOper(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1234,7 +1348,7 @@
   int wasnt_hopped = 0;
 #endif
 
-  if (alev < CHACCESS_CHANOP)
+  if (alev < CHACCESS_CHANOP && !IsOper(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1441,7 +1555,7 @@
  */
   if (alev <
       ((chptr->mode.mode & MODE_PRIVATE) ?
-        CHACCESS_CHANOP : CHACCESS_HALFOP))
+        CHACCESS_CHANOP : CHACCESS_HALFOP) && !IsOper(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1583,7 +1697,7 @@
   char *opnick;
   struct Client *targ_p;
 
-  if (alev < CHACCESS_HALFOP)
+  if (alev < CHACCESS_HALFOP && !IsOper(source_p))
   {
     if (!(*errors & SM_ERR_NOOPS))
       sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
@@ -1858,7 +1972,7 @@
   {chm_simple, (void *) MODE_NOPRIVMSGS},         /* n */
   {chm_op, NULL},                                 /* o */
   {chm_simple, (void *) MODE_PRIVATE},            /* p */
-  {chm_nosuch, NULL},                             /* q */
+  {chm_quiet, NULL},                             /* q */
   {chm_nosuch, NULL},                             /* r */
   {chm_simple, (void *) MODE_SECRET},             /* s */
   {chm_simple, (void *) MODE_TOPICLIMIT},         /* t */
diff -uNrd ircd-hybrid-7rc3/src/irc_string.c ircd-hoho-2r15/src/irc_string.c
--- ircd-hybrid-7rc3/src/irc_string.c	Thu May 30 22:21:03 2002
+++ ircd-hoho-2r15/src/irc_string.c	Fri Dec 20 15:37:24 2002
@@ -697,4 +697,34 @@
 }
 #endif
 
+char* strip_colour(char* string)
+{
+  char *c = string;
+  char *c2 = string;
+  /* c is source, c2 is target */
+  for (; c && *c; c++)
+    switch(*c)
+      {
+      case 3:
+    if (isdigit(c[1]))
+      {
+        c++;
+        if (isdigit(c[1]))
+          c++;
+        if (c[1] == ','&& isdigit(c[2]))
+          {
+        c+=2;
+        if (isdigit(c[1]))
+          c++;
+          }
+      }
+    break;
+      case 2: case 6: case 7: case 22: case 27: case 31:
+    break;
+      default:
+    *c2++ = *c;
+      }
+  *c2 = '\0';
+  return string;
+}
 
diff -uNrd ircd-hybrid-7rc3/src/ircd_lexer.l ircd-hoho-2r15/src/ircd_lexer.l
--- ircd-hybrid-7rc3/src/ircd_lexer.l	Mon Jul 22 01:08:01 2002
+++ ircd-hoho-2r15/src/ircd_lexer.l	Fri Dec 20 15:37:24 2002
@@ -155,6 +155,7 @@
 deny		{ return DENY; }
 description	{ return DESCRIPTION; }
 die		{ return DIE; }
+disable_auth    { return DISABLE_AUTH; }
 disable_hidden	{ return DISABLE_HIDDEN; }
 disable_local_channels { return DISABLE_LOCAL_CHANNELS; }
 disable_remote_commands	{ return DISABLE_REMOTE_COMMANDS; }
diff -uNrd ircd-hybrid-7rc3/src/ircd_parser.y ircd-hoho-2r15/src/ircd_parser.y
--- ircd-hybrid-7rc3/src/ircd_parser.y	Thu Aug 15 09:32:43 2002
+++ ircd-hoho-2r15/src/ircd_parser.y	Fri Dec 20 15:37:23 2002
@@ -117,6 +117,7 @@
 %token  DENY
 %token  DESCRIPTION
 %token  DIE
+%token  DISABLE_AUTH
 %token  DISABLE_HIDDEN
 %token  DISABLE_LOCAL_CHANNELS
 %token  DISABLE_REMOTE_COMMANDS
@@ -1960,6 +1961,7 @@
                     general_compression_level | general_client_flood |
                     general_throttle_time | general_havent_read_conf |
                     general_dot_in_ip6_addr | general_ping_cookie |
+                    general_disable_auth |
                     error;
 
 general_failed_oper_notice:   FAILED_OPER_NOTICE '=' TYES ';'
@@ -2316,6 +2318,15 @@
     PING_COOKIE '=' TNO ';'
   {
     ConfigFileEntry.ping_cookie = 0;
+  } ;
+
+general_disable_auth: DISABLE_AUTH '=' TYES ';'
+  {
+    ConfigFileEntry.disable_auth = 1;
+  } |
+    DISABLE_AUTH '=' TNO ';'
+  {
+    ConfigFileEntry.disable_auth = 0;
   } ;
 
 general_use_help: USE_HELP '=' TYES ';'
diff -uNrd ircd-hybrid-7rc3/src/messages.tab ircd-hoho-2r15/src/messages.tab
--- ircd-hybrid-7rc3/src/messages.tab	Mon Aug 19 21:02:29 2002
+++ ircd-hoho-2r15/src/messages.tab	Fri Dec 20 15:37:24 2002
@@ -428,7 +428,7 @@
 /* 401 ERR_NOSUCHNICK, */       ":%s 401 %s %s :No such nick/channel",
 /* 402 ERR_NOSUCHSERVER, */     ":%s 402 %s %s :No such server",
 /* 403 ERR_NOSUCHCHANNEL, */    ":%s 403 %s %s :No such channel",
-/* 404 ERR_CANNOTSENDTOCHAN, */ ":%s 404 %s %s :Cannot send to channel",
+/* 404 ERR_CANNOTSENDTOCHAN, */ ":%s 404 %s %s :What good is a phone call if you are unable to speak?",
 /* 405 ERR_TOOMANYCHANNELS, */  ":%s 405 %s %s :You have joined too many channels",
 /* 406 ERR_WASNOSUCHNICK, */    ":%s 406 %s %s :There was no such nickname",
 /* 407 ERR_TOOMANYTARGETS, */   ":%s 407 %s %s :Too many recipients.",
@@ -743,8 +743,8 @@
 /* 712 ERR_CHANOPEN */		":%s 713 %s %s :Channel is open.",
 /* 714 ERR_KNOCKONCHAN */	":%s 714 %s %s :You are already on that channel.",
 /* 715 ERR_KNOCKDISABLED */	":%s 715 %s :KNOCKs are disabled.",
-/* 716 */	NULL,
-/* 717 */	NULL,
+/* 716 RPL_QUIETLIST */		":%s 716 %s %s %s %s %lu",
+/* 717 RPL_ENDOFQUIETLIST */	":%s 717 %s %s :End of Channel Quiet List",
 /* 718 */	NULL,
 /* 719 */	NULL,
 /* 720 */	NULL,
diff -uNrd ircd-hybrid-7rc3/src/s_auth.c ircd-hoho-2r15/src/s_auth.c
--- ircd-hybrid-7rc3/src/s_auth.c	Fri Jul 19 11:51:34 2002
+++ ircd-hoho-2r15/src/s_auth.c	Fri Dec 20 15:37:24 2002
@@ -423,7 +423,9 @@
   adns_getaddr(&client->localClient->ip, client->localClient->aftype, client->localClient->dns_query);
   SetDNSPending(auth);
 
-  start_auth_query(auth);
+  if(ConfigFileEntry.disable_auth == 0) 
+    start_auth_query(auth);
+
   link_auth_request(auth, &auth_poll_list);
 }
 
diff -uNrd ircd-hybrid-7rc3/src/s_serv.c ircd-hoho-2r15/src/s_serv.c
--- ircd-hybrid-7rc3/src/s_serv.c	Thu Aug 15 10:15:37 2002
+++ ircd-hoho-2r15/src/s_serv.c	Fri Dec 20 15:37:24 2002
@@ -104,6 +104,7 @@
   { "ZIP",   CAP_ZIP },
   { "TBURST", CAP_TBURST },
   { "PARA",  CAP_PARA },
+  { "QU",    CAP_QU },
   { 0,           0 }
 };
 
